function SaleCancelController(AccountService, OperatorRepository, PermissionService, ScreenService, UtilitiesService, PaymentService, IntegrationService, IntegrationCappta, PrinterService, templateManager, PerifericosService){

	var self = this;

	this.saleCancel = function(widget){
		if (_.get(widget, 'currentRow.CODIGOCUPOM')){
			OperatorRepository.findOne().then(function(operatorData){
                //this.updateCancelVendaObservations(widget.currentRow, function () {

				if (
					!(_.get(widget, 'currentRow.TXPRODCOMVENCAN')) &&
					(operatorData.IDOBRIGAOBSCAN === 'S' ))
				{
					ScreenService.showMessage("Informe um motivo para o cancelamento.");
				} else {
					/*
					var chave = operatorData.chave;
					var selectedObs = _.get(widget.CurrentRow, 'CDOCORR', []);
					var motivo = [{
						'CDGRPOCOR': _.get(cancelVendaObservations[0], 'CDGRPOCOR', []),
						'CDOCORR': selectedObs[selectedObs.length - 1] || [], // salva CDOCORR da �ltima observa��o clicada
						'TXPRODCOMVEN': widget.CurrentRow.TXPRODCOMVENCAN
					}];
					if (operatorData.IDSOLOBSCAN=='N'){
						motivo = [{
							'CDGRPOCOR': '',
							'CDOCORR': [],
							'TXPRODCOMVEN': ''
						}];
					}
					*/
					widget.currentRow.CODIGOCUPOM = UtilitiesService.padLeft(
						widget.currentRow.CODIGOCUPOM,
						widget.getField('CODIGOCUPOM').maxlength,
						'0'
					);
					var saleCancelPopup = templateManager.containers
						.saleCancel.getWidget('saleCancelPopup');
					var saleCancelSelect = saleCancelPopup.getField('saleCancelSelect');
					AccountService.listNotas(
						operatorData.CDFILIAL, widget.currentRow.CODIGOCUPOM
					).then(function(result){
						if(result.length === 0){
							ScreenService.showMessage('Não foram encontradas vendas com este cupom.');
						}
						else if(result && Object.keys(result).length > 1){
							ScreenService.openPopup(saleCancelPopup);
							saleCancelSelect.dataSource.data = result;
							saleCancelSelect.openField();
						} else {
							AccountService.saleCancel(
								// enviar codigo caixa também
								operatorData.chave, widget.currentRow.CODIGOCUPOM,
								widget.CDSUPERVISOR,
								_.get(widget, 'currentRow.TXPRODCOMVENCAN'),
								result[0].CDCAIXA
							).then(function(saleCancelResult){
								saleCancelResult = saleCancelResult[0];
								if (!saleCancelResult.error) {
									self.clearScreen(widget);
									UtilitiesService.backMainScreen();
									ScreenService.showMessage(saleCancelResult.message, 'success').then(function(){
										self.handleSaleCancel(saleCancelResult.data);
									}.bind(this));
								} else {
									ScreenService.showMessage(saleCancelResult.message, 'alert');
								}
							});
						}
					});
				}
				//});
			});
		}
	};

	this.doSaleCancelFromSelect = function(widget){
		if (_.get(widget, 'currentRow.NRNOTAFISCALCE')) {
			OperatorRepository.findOne().then(function (operatorData) {
				var saleCancelWidget = templateManager.containers.saleCancel
					.getWidget("saleCancelWidget");
				if (
					!(_.get(saleCancelWidget, 'currentRow.TXPRODCOMVENCAN')) &&
					(operatorData.IDOBRIGAOBSCAN === 'S')
				) {
					ScreenService.showMessage("Informe um motivo para o cancelamento.");
				} else {
					AccountService.saleCancel(
						// enviar codigo caixa também
						operatorData.chave,
						widget.currentRow.NRNOTAFISCALCE,
						saleCancelWidget.CDSUPERVISOR,
						_.get(saleCancelWidget, 'currentRow.TXPRODCOMVENCAN'),
						widget.currentRow.CDCAIXA
					).then(function (saleCancelResult) {
						saleCancelResult = saleCancelResult[0];
						if (!saleCancelResult.error) {
							self.clearScreen(saleCancelWidget);
							self.clearScreen(widget);
							UtilitiesService.backMainScreen();
							ScreenService.showMessage(
							saleCancelResult.message, 'success'
							)
							.then(function () {
								self.handleSaleCancel(saleCancelResult.data);
							}.bind(this));
						} else {
							ScreenService.showMessage(saleCancelResult.message, 'alert');
							console.log('o erro passou por aqui');
						}
					}.bind(this));
				}
			}.bind(this));
		}
	};

	this.openSaleCancel = function(windowName){
		PermissionService.checkAccess('cancelaCupom').then(function(CDSUPERVISOR){
			self.showSaleCancel(windowName, CDSUPERVISOR);
		}.bind(this));
	};

	this.showSaleCancel = function(windowName, CDSUPERVISOR) {
		ScreenService.openWindow(windowName).then(function(){
			templateManager.container.getWidget('saleCancelWidget').CDSUPERVISOR = CDSUPERVISOR;
			ScreenService.toggleSideMenu();
		}.bind(this));
	};

	this.clearScreen = function(widget){
		widget.currentRow = {};
		OperatorRepository.findOne().then(function(operatorData){
			if(widget.getField('CODIGOCUPOM')){
				widget.getField('CODIGOCUPOM').maxlength = operatorData.IDTPEMISSAOFOS === 'SAT' ? 6 : 9;
			}
		});

		if(widget.getField('CDOCORR') && (widget.name =='saleCancelWidget')){
			OperatorRepository.findAll().then(function (data) {
				fdCancelMotive = widget.getField('cancelMotive');
				if ( fdCancelMotive ){
					fdCancelMotive.isVisible = data[0].IDSOLOBSCANCUP == 'S';
					if (data[0].IDOBRIGAOBSCAN == 'S' && data[0].IDSOLOBSCANCUP != 'S'){
						fdCancelMotive.isVisible = true;
					}
				}
				fdCDOCORR = widget.getField('CDOCORR');
				if ( fdCDOCORR ){
					fdCDOCORR.isVisible = data[0].IDSOLOBSCANCUP == 'S';
					if (data[0].IDOBRIGAOBSCAN == 'S' && data[0].IDSOLOBSCANCUP != 'S'){
						fdCDOCORR.isVisible = true;
					}
				}
			});
		}

	};

	this.handleSaleCancel = function(saleCancelResult){
		if (!_.isEmpty(saleCancelResult.dadosImpressao)){
			self.printSaleCancel(saleCancelResult.dadosImpressao).then(function(response){
				self.handleTransactionRefound(saleCancelResult);
			}.bind(this));
		} else {
			self.handleTransactionRefound(saleCancelResult);
		}
	};

	this.printSaleCancel = function(dadosImpressao){
		if(dadosImpressao.IDUTILIMPFRONT){
			var param = {};
			param.impressora = dadosImpressao.dadosImpressao;
			param.IDUTILIMPFRONT = dadosImpressao.IDUTILIMPFRONT;
			param.comandos = dadosImpressao.comandos;
			return PerifericosService.print(param).then(function () {});
		}
		PrinterService.printerCommand(PrinterService.TEXT_COMMAND, dadosImpressao.TEXTOCUPOM);
		PrinterService.printerCommand(PrinterService.BARCODE_COMMAND, dadosImpressao.TEXTOCODIGOBARRAS);
		PrinterService.printerCommand(PrinterService.QRCODE_COMMAND, dadosImpressao.TEXTOQRCODE);
		PrinterService.printerCommand(PrinterService.TEXT_COMMAND, dadosImpressao.TEXTORODAPE);
		PrinterService.printerSpaceCommand();

		return PrinterService.printerInit().then(function(result){
			if(result.error)
				ScreenService.alertNotification(result.message);
		});
	};

	this.handleTransactionRefound = function(saleCancelResult){
		var dataTEF = saleCancelResult.dataTEF;
		if (dataTEF[0].IDDESABTEF != 'S' && (dataTEF[0].IDTIPORECE == "1" || dataTEF[0].IDTIPORECE == "2" || dataTEF[0].IDTIPORECE == "H")) {
			dataTEF = _.filter(dataTEF, function(tiporece) {
				return PaymentService.checkIfMustCallIntegration(tiporece);
			}.bind(this));

			OperatorRepository.findOne().then(function(operatorData){
				if (!_.isEmpty(dataTEF) && operatorData.IDUTILTEF === 'T' && (!!window.cordova || !!window.ZhCieloAutomation || !!window.ZhADX8000Automation || !!window.ZhStoneAutomation)){
					self.tefRefound(dataTEF, operatorData);
				}
			});
		}
	};

	this.tefRefound = function(dataTEF, operatorData){
		// monta dados para estorno
		dataTEF = _.map(dataTEF, function(tiporece){
			tiporece.IDTPTEF = operatorData.IDTPTEF;
			var transactionDate;

			switch(tiporece.IDTPTEF) {
				case '2':
					tiporece.AUTHKEY = IntegrationCappta.getAUTHKEY(operatorData.AMBIENTEPRODUCAO);
					break;
				case '5':
					tiporece.DSENDIPSITEF = operatorData.DSENDIPSITEF;
					tiporece.CDLOJATEF = operatorData.CDLOJATEF;
					tiporece.CDTERTEF = operatorData.CDTERTEF;
					transactionDate = tiporece.DTHRINCMOV.split(" ")[0].replace('-', '').replace('-', '');
					tiporece.TRANSACTIONDATE = transactionDate.slice(6, 8) + transactionDate.slice(4, 6) + transactionDate.substring(0, 4);
					break;
				case '8':
					transactionDate = tiporece.DTHRINCMOV.split(" ")[0].replace('-', '').replace('-', '');
					tiporece.TRANSACTIONDATE = transactionDate.slice(6, 8) + transactionDate.slice(4, 6) + transactionDate.substring(0, 4);
                    break;
                case '9':
                	transactionDate = tiporece.DTHRINCMOV.split(" ")[0].replace('-', '').replace('-', '');
                	tiporece.TRANSACTIONDATE = transactionDate.slice(6, 8) + transactionDate.slice(4, 6) + transactionDate.substring(0, 4);
                	break;
			}

			return tiporece;
		}.bind(self));

		IntegrationService.reversalIntegration(self.mochRemovePaymentSale, dataTEF).then(function(reversalIntegrationResult){
			// chama impressão do comprovante de cancelamento TEF
			if (!reversalIntegrationResult.error){
				ScreenService.showMessage("TEF estornado com sucesso.", 'success');

				if(operatorData.IDTPTEF !== '4')
					PaymentService.printTEFVoucher(reversalIntegrationResult.data);
			} else {
				ScreenService.showMessage(reversalIntegrationResult.message).then(function(){
					PaymentService.handleRefoundTEFVoucher(reversalIntegrationResult.data);
				});
			}
		}.bind(this));
	};

	this.mochRemovePaymentSale = function(){
		return new Promise.resolve(true);
	};
}

Configuration(function(ContextRegister){
	ContextRegister.register('SaleCancelController', SaleCancelController);
});
